﻿#define  RC5_ManifestPath ExePath & "\Bin\vbRichClient5.manifest" 'define, the rel. Path to the RC5-manifest
#Include Once "RC5_FBObjects.bi" '<- RC5_FBObjects.bi already includes SimpleVariant.bi

'COM-Errors are always retrievable after each Call per: COMErr.Number and/or COMErr.Description
ShowCOMErrors = True '<- when set to False, then only the built-in MsgBox-Popups will be suppressed 

'A first "real Application", which demonstrates what an RC5-based Windows-App can look like,
'and what efforts are needed code-wise (it is not much - and it should be quite readable, I hope...) 

'Have tried to give the whole thing more structure with 2 FB-Modules, which are included now:
#include "mod3DHelpers.bas"
#include "modJSONModel.bas"

Dim Shared Model As RC5_JSON = CreateNewModel 'we create a Model, using a Function, defined in the include-file above
Dim Shared ViewHost As RC5_ScriptHost 'and there we host the View (defined in cfMain, cpTopB, cpLeft, cpPlot, cpStat as *.vbs)

Dim Shared BackFaceStyle As eBackFaceStyle, Alpha As Double, Zoom As Double, P As cProjection 'some more Variables, used for rendering 
Dim Shared AreaInfo As tAreaInfo, Quads() As c3DQuad 'some Containers, to hold our current 3D-Data 

'two helper-function-declares (their implementations come at the end of this Main-Module)
Declare Sub RenderOn(Srf As RC5_CairoSurface, BackColor As Long, Alpha As Double, BackFaceStyle As eBackFaceStyle)
Declare Sub QSIndirect(Arr() As Double, Ind() As Long, LB As Long=-1, UB As Long=-1)

'Well, since we already have a Model and a View defined above - here's the two Controller-Callbacks, which handle all the Event-stuff
Public Sub CB_Refresh(VSrf As vbVariant)
    Dim Srf As RC5_CairoSurface = VSrf
    P.FocalLength = 0.28 * P.PerspectiveDist * IIf(Srf.Width < Srf.Height, Srf.Width, Srf.Height) * Zoom 'auto-fit + zooming
    RenderOn Srf, &H181818, Alpha, BackFaceStyle
End Sub
Public Sub CB_ModelChanged(BoundCtlKey As vbVariant, CurValue As vbVariant)
  Select Case Str(BoundCtlKey)
    Case "cmbSceneType"
       Select Case CLng(CurValue)
          Case UnitCube:     ConstructUnitCubeAndFillQuads(AreaInfo, Quads())
          Case GaussianBell: FillAreaDataAs(GaussianBell, AreaInfo, -3, 3, -3, 3): NormalizeAreaDataAndFillQuads(AreaInfo, Quads())
          Case Rosenbrock:   FillAreaDataAs(Rosenbrock,   AreaInfo, -1, 1, -2, 3): NormalizeAreaDataAndFillQuads(AreaInfo, Quads())
       End Select
    Case "cmbBackFaceStyle": BackFaceStyle = CLng(CurValue)
    Case "udnAzimuth":       P.UpdateAngles CurValue, P.AltitudeDeg
    Case "udnAltitude":      P.UpdateAngles P.AzimuthDeg, CurValue
    Case "udnPerspDistance": P.PerspectiveDist = CurValue
    Case "udnZoom":          Zoom = CurValue
    Case "udnAlpha":         Alpha = CurValue
  End Select
End Sub

'*** more Resource-stuff... (note, that all the Resources could also come from a DB, even the View-Def *.vbs-Scripts and the JSON-Model)

'add a few Image-Resources into the global Cairo-ImageList (Process-wide retrievable "By-Key" from any Form or Widget)
IL.AddImage "frmDefault", ExePath & "\Res\frmDefault.png" 'used as the Form-Icon (ImgKey will be applied in cfMain.vbs)
IL.AddImage "Logo", ExePath & "\Res\Logo.png" 'used in the TopBar-Panel (ImgKey will be applied in cpTopB.vbs)
IL.AddImage "FullScreen", ExePath & "\Res\FullScreen.png" 'also used in the TopBar-Panel (on the FullScreenSwitch-Button)
IL.AddImage "Info", ExePath & "\Res\Info.png" 'used in the StatusBar-Panel (ImgKey will be applied in cpStat.vbs)


'the Area-Definition below will later result in 80x80=6400 Quad-Objects we have to handle (with roughly 25FPS, but 
'that's sufficient IMO for "non-game-scenarios" - the render-quality looks good, and the cairo-API is comfortable to use)
ReDim AreaInfo.Area3D(80, 80) 

'Now we add the (VBScript-based, but not very large) View-Definitions (starting with the Panels, and ending with the hosting Form-Def)
ViewHost.AddCode FSO.ReadTextContent(ExePath & "\ClassDefs\cpTopB.vbs", CP_UTF8)
ViewHost.AddCode FSO.ReadTextContent(ExePath & "\ClassDefs\cpStat.vbs", CP_UTF8)
ViewHost.AddCode FSO.ReadTextContent(ExePath & "\ClassDefs\cpLeft.vbs", CP_UTF8)
ViewHost.AddCode FSO.ReadTextContent(ExePath & "\ClassDefs\cpPlot.vbs", CP_UTF8)
ViewHost.AddCode FSO.ReadTextContent(ExePath & "\ClassDefs\cfMain.vbs", CP_UTF8)

'Since the View is "physically in place", we can now bind our Model (already created per modJSONModel) to the Widgets in the View-Form
ViewHost.Call("Run", "wv", "InitWithModel", @Model)
 
'this will make our Controller-CallBack-Addresses known in two Variables of the View-Form (cfMain.vbs)
ViewHost.Exec "CB_ModelChanged=" & @CB_ModelChanged
ViewHost.Exec "CB_Refresh="      & @CB_Refresh

'set the initial Scroll-Positions of the Combo- and Up/Down-Widgets (we do this over the Model-DataSources here, and *not* over the Widgets)
With ViewHost.Eval("Controller.DataSources")
    .Get("Item", "w", "cmbSceneType").Put("AbsolutePosition", "l", 2)
    .Get("Item", "w", "cmbBackFaceStyle").Put("AbsolutePosition", "l", 2)
    .Get("Item", "w", "udnAzimuth").Put("AbsolutePosition", "l", 331)
    .Get("Item", "w", "udnAltitude").Put("AbsolutePosition", "l", 151)
    .Get("Item", "w", "udnZoom").Put("AbsolutePosition", "l", 4)
    .Get("Item", "w", "udnAlpha").Put("AbsolutePosition", "l", 5)
    .Get("Item", "w", "udnPerspDistance").Put("AbsolutePosition", "l", 8)
End With

'***** Ok, we're done with all the initialization-stuff *****

ViewHost.Exec "Form.Show" 'so, time to show our Form (since everything is prepared and connected now)
ViewHost.Exec "Cairo.WidgetForms.EnterMessageLoop" '<- the Application exits, when we leave this MessagePump


'what comes below, is only two helper-functions, which are needed by the CB_Refresh-Procedure above (one of the Controller-CallBacks)
Sub RenderOn(Srf As RC5_CairoSurface, BackColor As Long, Alpha As Double, BackFaceStyle As eBackFaceStyle)
    Dim CC As RC5_CairoContext = Srf.CreateContext
        CC.SetSourceColor BackColor: CC.Paint 'clear the surface
        CC.Translate Srf.Width / 2, Srf.Height / 2 'center the (0,0)-origin in the middle of the Surface-CC
  
    Static Ind() As Long, Dis() As Double: ReDim Preserve Dis(0 To UBound(Quads))
    For i As Long = 0 To UBound(Quads)
        Dis(i) = Quads(i).ReCalculateOn(P) 'returns the average-dist of each Quad from the Eye
    Next
        QSIndirect Dis(), Ind() 'now let's sort (indirectly) by that Eye-Distance
    For i As Long = 0 To UBound(Quads)
        Quads(Ind(i)).DrawOn CC, Alpha, BackFaceStyle 'and render the Quads (those most distant come first)
    Next
 
    ''we are done with the expensive renderings... (what remains is only the Z-Color-Infos at the left-hand-side of the Surface)
    CC.MatrixResetToIdentity 'switch back to normal TopLeft-Coords
    CC.RenderSurfaceContent Spectrum.LutSrf, 6, Srf.Height - 6, 3, -Srf.Height + 12 'render the Z-LUT-Gradient at the left
    CC.SelectFont "Arial", 8, &HEEEEEE
    CC.TextOut 11, 3, "Z-Max: " & Format$(AreaInfo.zMax * AreaInfo.zScale, "0.00")
    CC.TextOut 11, Srf.Height - 17, "Z-Min: " & Format$(AreaInfo.zMin * AreaInfo.zScale, "0.00")
End Sub

Sub QSIndirect(Arr() As Double, Ind() As Long, LB As Long=-1, UB As Long=-1) 'used in the Sub above, to sort the Quads by Eye-Distance
    Dim As Long M1, M2, Pivot

    If LB = -1 And UB = -1 Then 'our first time, so we init the Indirect-Index-Array once
       LB = LBound(Arr): UB = UBound(Arr): ReDim Preserve Ind(LB To UB)
       For i as Long = LB To UB: Ind(i) = i: Next
    End If

    M1 = LB: M2 = UB: Pivot = Ind((M1 + M2) \ 2)

    Do
      Do While Arr(Ind(M1)) < Arr(Pivot): M1 += 1: Loop
      Do While Arr(Ind(M2)) > Arr(Pivot): M2 -= 1: Loop

      If M1 <= M2 Then Swap Ind(M1), Ind(M2): M1 += 1: M2 -= 1
    Loop Until M1 > M2
 
    If LB < M2 Then QSIndirect Arr(), Ind(), LB, M2
    If M1 < UB Then QSIndirect Arr(), Ind(), M1, UB
End Sub
