﻿Dim Form
Set Form = Cairo.WidgetForms.Create(vbSizable, "3D-Surface-Rendering-Cairo", False, 861, 661)
    Form.SetMinMaxDimensions 640, 480
    Form.IconImageKey = "frmDefault"
    
    With Cairo.ToolTipWidget.Widget 'adjust the global Cairo-Tooltip to a somewhat darker Color-Theme
        .Alpha = 0.88
        .BackColor = &H333333
        .ForeColor = &HA09033
    End With
    
Dim tmrAnimate: Set tmrAnimate = New_c.Timer(10, False)
Dim Controller: Set Controller = Cairo.DataSourceDispatcher

'the above 3 Objects are the only ones, we need Events from in this Form-Definition
AddEventSupportFor "Form" 
AddEventSupportFor "tmrAnimate"
AddEventSupportFor "Controller"

Dim CB_Refresh 'a PlaceHolder-Property for the FB-CallBack-Address
Dim CB_ModelChanged 'and another such Callback-Stub (which gets externally filled later)

Dim Srf, TS, FPS 'a Cairo-Surface, a TimeStamp- and an FPS-Variable

Const TopBHeight = 45, LeftWidth = 150, StatHeight = 33 'Consts for the Panel-Sizes
Dim pnlTopB, pnlLeft, pnlStat, pnlPlot 'the four Panels we arrange (fully covering the Form)
 
Sub InitWithModel(Model) 'called externally to make the Controller known to the external Model
  For i = 0 To Model.Count - 1 'binds the JSON-Entries to the Controls in the LeftPanel (by CtlName-Key)
    Controller.AddBindingSource Model.ItemByIndex(i), Model.KeyByIndex(i)
  Next
  'now that the Model-DataSources are in place, we can add all 4 Child-Panels to the Form
  Set pnlTopB = New cpTopB: pnlTopB.InitOn Form.hWnd, TopBHeight 
  Set pnlStat = New cpStat: pnlStat.InitOn Form.hWnd, StatHeight
  Set pnlLeft = New cpLeft: pnlLeft.InitOn Form.hWnd
  Set pnlPlot = New cpPlot: pnlPlot.InitOn Form.hWnd
End Sub

Sub Refresh()
  If ObjPtr(Srf)=0 Or CB_Refresh = 0 Then Exit Sub
  
  New_c.stdcall 0, CB_Refresh, VarPtr(Srf) 
  pnlPlot.FlipToPanelBackGround Srf
End Sub

Private Sub Controller_Move(BindingSource, NewRowIdxZeroBased)
  If NewRowIdxZeroBased < 0 Or CB_ModelChanged = 0 Then Exit Sub
  
  Dim BdKey: BdKey = BindingSource.Key
  Dim Value: Value = BindingSource.FieldValue("Value")
  New_c.stdcall 0, CB_ModelChanged, VarPtr(BdKey), VarPtr(Value)
  If Not (tmrAnimate.Enabled And (BindingSource.Key = "udnAzimuth" Or BindingSource.Key = "udnAltitude")) Then Refresh
End Sub

Private Sub Controller_PropValueChange(BindingSource, Key, Value, OldValue)
  If BindingSource.Key = "chkAnimate" Then tmrAnimate.Enabled = Value
  If BindingSource.Key = "chkFullScreen" Then Form.FullScreen = Value
End Sub

Private Sub Form_ResizeWithDimensions(NewWidth, NewHeight)
  pnlTopB.chkFullScreen.Widget.Move NewWidth - 41, 8 'the chkFullScreen-Button in the TopBar will be adjusted as well
  pnlTopB.Panel.Move 0, 0, NewWidth, TopBHeight
  pnlLeft.Panel.Move 0, TopBHeight, LeftWidth, NewHeight - TopBHeight - StatHeight
  pnlStat.Panel.Move 0, NewHeight - StatHeight, NewWidth, StatHeight
  pnlPlot.Panel.Move LeftWidth, TopBHeight, NewWidth - LeftWidth, NewHeight - TopBHeight - StatHeight
  
  Set Srf = Cairo.CreateSurface(pnlPlot.Panel.Width, pnlPlot.Panel.Height)
  Refresh
End Sub

Private Sub tmrAnimate_Timer()
  Controller.DataSources("udnAzimuth").AbsolutePosition  = 360 - (361 - _ 
  Controller.DataSources("udnAzimuth").AbsolutePosition) Mod 360 
  
  Controller.DataSources("udnAltitude").AbsolutePosition = 360 - (361 - _
  Controller.DataSources("udnAltitude").AbsolutePosition) Mod 360 
  
  FPS = FPS + 1
  If New_c.HPTimer - TS > 0.25 Then 'report status only every quarter-second
      pnlStat.ChangeStatus "FPS: " & FPS * 4: FPS = 0: TS = New_c.HPTimer
  End If
  Refresh
End Sub