﻿#define UNICODE
#Include Once "SimpleVariant.bi"
#Include Once "RC5_FBEnums.bi"

'The UDT-Class-Defs below allow more convenience, by wrapping RC5-Class-Instances in an FB-structure (Extending vbVariant) -
'due to the LateBinding-approach we favour here, the implementation of these FB-UDT-Methods becomes pretty straight-forward

'ensure Shared Instances of the (New_c) vbRichClient5.cConstructor-instance and Cairo (which acts as a constructor-class for the cairo-objects)
Dim Shared New_c As vbVariant = CreateObjectRegFree("vbRichClient5.cConstructor", RC5_ManifestPath) 
Dim Shared Cairo As vbVariant = New_c.Get("Cairo") 
 
'-------------------------- Start of the Class-Wrapper-Section -------------------------
 
'*** a Wrapper around the RC5-FileSystemObject (which only in name resembles the MS-Scripting-FSO, it has much more to offer)
Type RC5_FSO Extends vbVariant
    Declare Constructor(RHS As vbVariant)
    Declare Function ReadTextContent(FileName As String, CodePage As Long=CP_UTF8) As String
    Declare Function ReadByteContent(FileName As String) As vbVariant
End Type '<- define the Parent-Obj (usually New_c or Cairo), followed by the constructing MethodName, as expected by the RC5-ParentObject
Constructor RC5_FSO(RHS As vbVariant)
    V = RHS
End Constructor
Function RC5_FSO.ReadTextContent(FileName As String, CodePage As Long=CP_UTF8) As String
    Return This.Get("ReadTextContent", "sbl", FileName, False, CodePage)
End Function
Function RC5_FSO.ReadByteContent(FileName As String) As vbVariant
    ReadByteContent= This.Get("ReadByteContent", "s", FileName)
End Function
Dim Shared FSO As RC5_FSO = New_c.Get("FSO")  'at this occasion, we instantiate it already, since it is one of those which make sense "App-wide" as well

'*** a Wrapper around the RC5-Cairo-Pattern
Type RC5_CairoPattern Extends vbVariant
    'Declare Constructor()
    Declare Constructor(SolidColor As Long, Alpha As Double=1, Shade As Double=1) 'for a solid Pattern
    Declare Constructor(X0 As Double, Y0 As Double, X1 As Double, Y1 As Double) 'for a linear Pattern
    Declare Constructor(cx0 As Double, cy0 As Double, Radius0 As Double, cx1 As Double, cy1 As Double, Radius1 As Double) 'for a radial Pattern
    Declare Sub AddColorStop(Offset As Double, StopColor As Long, Alpha As Double=1, Shade As Double=1)
End Type
Constructor RC5_CairoPattern(SolidColor As Long, Alpha As Double=1, Shade As Double=1)
    V = Cairo.Call("CreateSolidPattern", "ldd", SolidColor, Alpha, Shade)
End Constructor
Constructor RC5_CairoPattern(X0 As Double, Y0 As Double, X1 As Double, Y1 As Double)
    V = Cairo.Call("CreateLinearPattern", "dddd", X0, Y0, X1, Y1)
End Constructor
Constructor RC5_CairoPattern(cx0 As Double, cy0 As Double, Radius0 As Double, cx1 As Double, cy1 As Double, Radius1 As Double)
    V = Cairo.Call("CreateRadialPattern", "dddddd", cx0, cy0, Radius0, cx1, cy1, Radius1)
End Constructor
Sub RC5_CairoPattern.AddColorStop(Offset As Double, StopColor As Long, Alpha As Double=1, Shade As Double=1)
    This.Call("AddColorStop", "dldd", Offset, StopColor, Alpha, Shade)
End Sub

'*** a Wrapper around the RC5-Cairo-Context
Type RC5_CairoContext Extends vbVariant
    Declare Constructor()
    Declare Constructor(RHS As vbVariant)
    Declare Sub SetSourceColor(ColorValue As Long, Alpha As Double=1, Shade As Double=1)
    Declare Sub Paint(Alpha As Double=1)
    Declare Sub Paint(Alpha As Double, Pat As RC5_CairoPattern)
    Declare Sub Fill(DontClosePath As Boolean=False)
    Declare Sub Stroke(DontClosePath As Boolean=False)
    Declare Sub SetLineWidth(LineWidth As Double)
    Declare Sub SelectFont(FontName As String, FontSize As Double, TextColor As Long=0, Bold As Boolean=False, Italic As Boolean=False, Underline As Boolean=False, StrikeThrough As Boolean=False)
    Declare Sub TextOut(x As Double, y As Double, Text As String, BaseLine As Boolean=False, Alpha As Double=1, PathOnly As Boolean=False)
    Declare Function GetFontHeight(ByRef TextHeight As Double=0) As Double
    Declare Function GetTextExtents(Text As String, ByRef FontHeight As Double=-1, ByRef TextHeight As Double=-1) As Double
    Declare Function DrawText(x As Double, y As Double, dx As Double, dy As Double, Text As String, SingleLine As Boolean=False, Alignment As Long=0, InnerSpace As Long=0, VAlign As Long=0, ExtendedFlags As Long=0, Alpha As Double=1, PathOnly As Boolean=False, ByRef MaxDxNeeded As Double=0) As Long
    Declare Sub DrawTextCell (x As Double, y As Double, dx As Double, dy As Double, Text As String, SingleLine As Boolean=False, Alignment As Long=0, InnerSpace As Double=1, FillColor As Long=&Hffffff, GradientShade As Double=0, LineColor As Long=0, LineWidth As Double=0.5)
    Declare Sub Save()
    Declare Sub Restore()
    Declare Sub MatrixResetToIdentity()
    Declare Sub Translate(tX As Double, tY As Double)
    Declare Sub Scale(sX As Double, sY As Double)
    Declare Sub Rotate(Angle As Double, AngleIsRad As Boolean=False)
    Declare Sub PolygonPtr(PtrDbl As Double Ptr, PairsCount As Long, ClosePath As Boolean=False, BSplineInterpolation As SplineInterpolationEnm=0, BSplineClamp As Boolean=False, MeetControlPoints As Boolean=False)
    Declare Sub RenderSurfaceContent(SurfaceOrImageListKey As vbVariant, DstX As Double=0, DstY As Double=0, DstDX As Double=0, DstDY As Double=0, Filter As cairo_filter_enm=CAIRO_FILTER_GOOD, Alpha As Double=1, KeepAspectRatio As Boolean=False)
End Type
Constructor RC5_CairoContext()
End Constructor
Constructor RC5_CairoContext(RHS As vbVariant)
    V = RHS
End Constructor
Sub RC5_CairoContext.SetSourceColor(ColorValue As Long, Alpha As Double=1, Shade As Double=1) 
    Static DispID As Long: UseDispId = DispID
      This.Call("SetSourceColor", "ldd", ColorValue, Alpha, Shade)
    If DispID = 0 And LastDispID > 0 Then DispID = LastDispID 
End Sub
Sub RC5_CairoContext.Paint(Alpha As Double=1)  
    This.Call("Paint", "d", Alpha)
End Sub
Sub RC5_CairoContext.Paint(Alpha As Double, Pat As RC5_CairoPattern)  
    This.Call("Paint", "dv", Alpha, @Pat.V)
End Sub
Sub RC5_CairoContext.Fill(DontClosePath As Boolean=False) 
    Static DispID As Long: UseDispId = DispID
    This.Call("Fill", "b", DontClosePath)
    If DispID = 0 And LastDispID > 0 Then DispID = LastDispID
End Sub
Sub RC5_CairoContext.Stroke(DontClosePath As Boolean=False)  
    This.Call("Stroke", "b", DontClosePath)
End Sub
Sub RC5_CairoContext.SetLineWidth(LineWidth As Double) 
    This.Call("SetLineWidth", "d", LineWidth)
End Sub
Sub RC5_CairoContext.SelectFont(FontName As String, FontSize As Double, TextColor As Long=0, Bold As Boolean=False, Italic As Boolean=FALSE, Underline As Boolean=FALSE, StrikeThrough As Boolean=FALSE)
    This.Call("SelectFont", "sdlbbbb", FontName, FontSize, TextColor, Bold, Italic, Underline, StrikeThrough)
End Sub
Sub RC5_CairoContext.TextOut(x As Double, y As Double, Text As String, BaseLine As Boolean=FALSE, Alpha As Double=1, PathOnly As Boolean=FALSE)
    This.Call("TextOut", "ddsbdb", x, y, Text, BaseLine, Alpha, PathOnly)
End Sub
Function RC5_CairoContext.GetFontHeight (ByRef TextHeight As Double=0) As Double
    Return This.Call("GetFontHeight", "D", @TextHeight) 
End Function
Function RC5_CairoContext.GetTextExtents(Text As String, ByRef FontHeight As Double=-1.0, ByRef TextHeight As Double=-1.0) As Double
    Return This.Call("GetTextExtents", "sDD", Text, @FontHeight, @TextHeight) 
End Function
Function RC5_CairoContext.DrawText(x As Double, y As Double, dx As Double, dy As Double, Text As String, SingleLine As Boolean=FALSE, Alignment As Long=0, InnerSpace As Long=0, VAlign As Long=0, ExtendedFlags As Long=0, Alpha As Double=1, PathOnly As Boolean=False, ByRef MaxDxNeeded As Double=0) As Long
    'Returns the amount of needed Rows... and when dy=0 is passed, this would ensure the "Just-Calc"-Mode, not causing any Drawings (yet)
    Return This.Call("DrawText", "ddddsblllldbD", x, y, dx, dy, Text, SingleLine, Alignment, InnerSpace, VAlign, ExtendedFlags, Alpha, PathOnly, @MaxDxNeeded )
End Function
Sub RC5_CairoContext.DrawTextCell (x As Double, y As Double, dx As Double, dy As Double, Text As String, SingleLine As Boolean=FALSE, Alignment As Long=0, InnerSpace As Double=1, FillColor As Long=&Hffffff, GradientShade As Double=0, LineColor As Long=0, LineWidth As Double=0.5)
    This.Call("DrawTextCell", "ddddsbldldld", x, y, dx, dy, Text, SingleLine, Alignment, InnerSpace, FillColor, GradientShade, LineColor, LineWidth)
End Sub
 Sub RC5_CairoContext.Save()
    This.Call("Save")
 End Sub
 Sub RC5_CairoContext.Restore()
    This.Call("Restore")
 End Sub
 Sub RC5_CairoContext.MatrixResetToIdentity()
    This.Call("MatrixResetToIdentity")
 End Sub
 Sub RC5_CairoContext.Translate(tX As Double, tY As Double)
     This.Call("TranslateDrawings", "dd", tX, tY)
 End Sub
 Sub RC5_CairoContext.Scale(sX As Double, sY As Double)
     This.Call("ScaleDrawings", "dd", sX, sY)
 End Sub
 Sub RC5_CairoContext.Rotate(Angle As Double, AngleIsRad As Boolean=False)
     If AngleIsRad Then This.Call("RotateDrawings", "d", Angle) Else This.Call("RotateDrawingsDeg", "d", Angle)
 End Sub
Sub RC5_CairoContext.PolygonPtr(PtrDbl As Double Ptr, PairsCount As Long, ClosePath As Boolean=False, BSplineInterpolation As SplineInterpolationEnm=0, BSplineClamp As Boolean=False, MeetControlPoints As Boolean=False)
    Static DispID As Long: UseDispId = DispID
    This.Call("PolygonPtr", "llblbb", PtrDbl, PairsCount, ClosePath, BSplineInterpolation, BSplineClamp, MeetControlPoints)
    If DispID = 0 And LastDispID > 0 Then DispID = LastDispID 
End Sub
Sub RC5_CairoContext.RenderSurfaceContent(SurfaceOrImageListKey As vbVariant, DstX As Double=0, DstY As Double=0, DstDX As Double=0, DstDY As Double=0, Filter As cairo_filter_enm=CAIRO_FILTER_GOOD, Alpha As Double=1, KeepAspectRatio As Boolean=False)
    Static DispID As Long: UseDispId = DispID
    This.Call("RenderSurfaceContent", "vddddldb", @SurfaceOrImageListKey.V, Dstx, DstY, DstDX, DstDY, Filter, Alpha, KeepAspectRatio)
    If DispID = 0 And LastDispID > 0 Then DispID = LastDispID 
End Sub


'*** a Wrapper around the RC5-Cairo-Surface
Type RC5_CairoSurface Extends vbVariant
    Declare Constructor()
    Declare Constructor(RHS As vbVariant)
    Declare Constructor(dx As ULong=1, dy As ULong=1, SrfType As SurfaceCreateEnum=ImageSurface, DXorGLhWnd As Long=0, DXWaitForVerticalBlanc As Boolean=False)
    Declare Function CreateContext() As RC5_CairoContext
    Declare Function Width() As Long
    Declare Function Height() As Long
    Declare Function Stride() As Long
    Declare Function DataPtr() As Any Ptr
    Declare Function SurfaceType() As Long
    Declare Sub FastBlur()
    Declare Sub Sharpen()
    Declare Function WriteContentToPngFile(FileName As String) As Long
    Declare Function WriteContentToJpgFile(FileName As String, QualityPercent As Long = 90, WithAlpha As Boolean=False) As Long
    Declare Sub DrawToDC(hDC As Long, x As Long=0, y As Long=0, dx As Long=0, dy As Long=0, xSrc As Long=0, ySrc As Long=0, dxSrc As Long=0, dySrc As Long=0, ROp As Long=&HCC0020, HalfTone As Boolean=True, KeepAspectRatio As Boolean=False)
End Type
Constructor RC5_CairoSurface()
    V = Cairo.Call("CreateSurface", "ll", 1, 1)
End Constructor
Constructor RC5_CairoSurface(RHS As vbVariant)
   'Clear
    V = RHS
End Constructor
Constructor RC5_CairoSurface(dx As ULong=1, dy As ULong=1, SrfType As SurfaceCreateEnum=ImageSurface, DXorGLhWnd As Long=0, DXWaitForVerticalBlanc As Boolean=False)
    Dim VMissing As tagVariant: VMissing.VT = vbError: VMissing.lVal = &H80020004 'defines a Missing Optional Variant-Param
    V = Cairo.Call("CreateSurface", "lllvll", dx, dy, SrfType, @VMissing, DXorGLhWnd, DXWaitForVerticalBlanc)
End Constructor
Function RC5_CairoSurface.CreateContext() As RC5_CairoContext 
    Dim CC As RC5_CairoContext = This.Get("CreateContext")
    Return CC
End Function
Function RC5_CairoSurface.Width() As Long
	Return This.Get("Width") 
End Function
Function RC5_CairoSurface.Height() As Long
    Return This.Get("Height") 
End Function
Function RC5_CairoSurface.Stride() As Long
    Return This.Get("Stride") 
End Function
Function RC5_CairoSurface.DataPtr() As Any Ptr
    Return Cast(Any Ptr, CInt(This.Get("DataPtr")))
End Function
Function RC5_CairoSurface.SurfaceType() As Long
    Return This.Get("SurfaceType")
End Function
Sub RC5_CairoSurface.FastBlur()
    This.Call("FastBlur")
End Sub
Sub RC5_CairoSurface.Sharpen()
    This.Call("Sharpen")
End Sub
Function RC5_CairoSurface.WriteContentToPngFile(FileName As String) As Long
    Return This.Call("WriteContentToPngFile", "s", FileName)
End Function
Function RC5_CairoSurface.WriteContentToJpgFile(FileName As String, QualityPercent As Long = 90, WithAlpha As Boolean=False) As Long
    Return This.Call("WriteContentToJpgFile", "slb", FileName, QualityPercent, WithAlpha) 
End Function
Sub RC5_CairoSurface.DrawToDC(hDC As Long, x As Long=0, y As Long=0, dx As Long=0, dy As Long=0, xSrc As Long=0, ySrc As Long=0, dxSrc As Long=0, dySrc As Long=0, ROp As Long=&HCC0020, HalfTone As Boolean=True, KeepAspectRatio As Boolean=False)
    This.Call("DrawToDC", "llllllllllbb", hDC, x, y, dx, dy, xSrc, ySrc, dxSrc, dySrc, ROp, HalfTone, KeepAspectRatio)
End Sub


'*** a Wrapper around the (process-global) RC5-Cairo.ImageList (so, only one instance of that Class is needed per FB-App)
'*** everything one adds into it (per String-Key) is usable in any RC5-Widget or -Form by just applying that String-Key)
Type RC5_ImageList Extends vbVariant
    Declare Constructor(RHS As vbVariant)
    Declare Sub AddImage(Key As String, FileName As String, DesiredWidth As Long=0, DesiredHeight As Long=0, KeepAspectRatio As Boolean=False) 
    Declare Function AddSurface(Key As String, Surface As RC5_CairoSurface) As RC5_CairoSurface
    Declare Sub Remove(Key As String)
    Declare Function Item(Key As String) As RC5_CairoSurface
End Type
Constructor RC5_ImageList(RHS As vbVariant)
    V = RHS
End Constructor
Sub RC5_ImageList.AddImage(Key As String, FileName As String, DesiredWidth As Long=0, DesiredHeight As Long=0, KeepAspectRatio As Boolean=False) 
    This.Call("AddImage", "ssllb", Key, FileName, DesiredWidth, DesiredHeight, KeepAspectRatio)
End Sub
Function RC5_ImageList.AddSurface(Key As String, Surface As RC5_CairoSurface) As RC5_CairoSurface
    Dim Srf As RC5_CairoSurface
        Srf = Surface 
        Srf.V = This.Call("AddSurface", "sv", Key, @Srf)
    Function = Srf
    Srf.V.VT=0
End Function
Sub RC5_ImageList.Remove(Key As String)
    This.Call("Remove", "s", Key)
End Sub
Function RC5_ImageList.Item(Key As String) As RC5_CairoSurface
    Dim Srf As RC5_CairoSurface
        Srf.V = This.Get("Item", "s", Key)
    Return Srf
End Function
Dim Shared IL As RC5_ImageList = Cairo.Get("ImageList")  'at this occasion, we instantiate it already, since it is one of those which make sense "App-wide" as well


'*** a Wrapper around the RC5-ScriptHost Implementation
Type RC5_ScriptHost Extends vbVariant
    Declare Constructor()
    Declare Property State() As Long
    Declare Property State(RHS As Long)
    Declare Sub      AddObject(ObjName As String, Obj As vbVariant, AddMembers As Boolean=False, IsEventSource As Boolean=False, AddTypeLib As Boolean=False)
    Declare Sub      AddCode  (Code As String) 
    Declare Sub      AddClsDef(Code As String) 
    Declare Sub      AddFrmDef(Code As String, FormName As String)
    Declare Sub      Exec     (Code As String) 
    Declare Function Eval     (Code As String) As vbVariant
    Declare Function LastErrString() As String
End Type
Constructor RC5_ScriptHost()
    V = New_c.Get("ActiveScript")
End Constructor
Property RC5_ScriptHost.State() As Long
    Return This.Get("State") 
End Property
Property RC5_ScriptHost.State(RHS As Long)
    This.Put("State", "l", RHS)
End Property
Sub RC5_ScriptHost.AddObject(ObjName As String, Obj As vbVariant, AddMembers As Boolean=False, IsEventSource As Boolean=False, AddTypeLib As Boolean=False) 
    This.Call("AddObject", "svbbb", ObjName, @Obj.V, AddMembers, IsEventSource, AddTypeLib)
End Sub
Sub RC5_ScriptHost.AddCode(Code As String)
    This.Call("AddCode", "s", Code)
End Sub
Sub RC5_ScriptHost.AddClsDef(Code As String) 
    AddCode(Code) 'add the Code of a VBScript-based (Widget-)Class-Definition
End Sub
Sub RC5_ScriptHost.AddFrmDef(Code As String, FormName As String) 
    Exec "FormName = """ & FormName & """"
    AddCode(Code) 'add the Code of a VBScript-based Form-Definition
    This.Put("SiteHwnd", "l", CLng(Eval("Form.hWnd")))
End Sub
Sub RC5_ScriptHost.Exec(Code As String) 'used for assignments and statement-execution of existing code
    This.Call("ExecuteStatement", "s", Code)
End Sub
Function RC5_ScriptHost.Eval(Code As String) As vbVariant
    Return Call("Eval", "s", Code)
End Function
Function RC5_ScriptHost.LastErrString() As String
    Return This.Get("LastErrString")
End Function


'*** a Wrapper around the RC5-SQLite-cRecordset (both, cRecordset and cConnection don't depend on ADO, but are quite ADO-compatible interface-wise) 
Type RC5_Recordset Extends vbVariant
    Declare Constructor()
    Declare Constructor(RHS As vbVariant)
    Declare Function RecordCount() As Long
    Declare Function FieldCount As Long
    Declare Function BOF() As Boolean
    Declare Function EOF() As Boolean
    Declare Sub MoveFirst() 
    Declare Sub MoveLast()
    Declare Sub MoveNext()
    Declare Sub MovePrevious()
    Declare Sub AddNew()
    Declare Sub DeleteRecord()
    Declare Sub UpdateBatch()
    Declare Property AbsolutePosition() As Long
    Declare Property AbsolutePosition(RHS As Long)
    Declare Property Sort() As String
    Declare Property Sort(RHS As String)  
    Declare Property FieldValue(FieldKey As String) As vbVariant
    Declare Property FieldValue(FieldKey As String, RHS As vbVariant)
    Declare Property FieldValue(FieldIdx As Long) As vbVariant
    Declare Property FieldValue(FieldIdx As Long, RHS As vbVariant)
    Declare Function FieldName(FieldIdx As Long) As String
    Declare Function ValueMatrix(RowIdx As Long, ColIdx As Long) As vbVariant
End Type
Constructor RC5_Recordset()
    Dim Rs As vbVariant = New_c.Get("Recordset")
    Dim Ds As vbVariant = New_c.Get("DataSource")
        Ds.Call("Init", "vw", @Rs, "")
    V = Ds 
End Constructor
Constructor RC5_Recordset(RHS As vbVariant)
    V = RHS
End Constructor
Function RC5_Recordset.RecordCount() As Long
    Return This.Call("RecordCount")
End Function
Function RC5_Recordset.FieldCount() As Long
    Return This.Call("FieldCount")
End Function
Function RC5_Recordset.BOF() As Boolean
    Return This.Call("BOF")
End Function
Function RC5_Recordset.EOF() As Boolean
    Return This.Call("EOF")
End Function
Sub RC5_Recordset.MoveFirst()
    This.Call("MoveFirst")
End Sub
Sub RC5_Recordset.MoveLast()
    This.Call("MoveLast")
End Sub
Sub RC5_Recordset.MoveNext()
    This.Call("MoveNext")
End Sub
Sub RC5_Recordset.MovePrevious()
    This.Call("MovePrevious")
End Sub
Sub RC5_Recordset.AddNew()
    This.Call("AddNew")
End Sub
Sub RC5_Recordset.DeleteRecord()
    This.Call("Delete")
End Sub
Sub RC5_Recordset.UpdateBatch()
    This.Call("UpdateBatch")
End Sub
Property RC5_Recordset.AbsolutePosition() As Long
    Return This.Get("AbsolutePosition")
End Property
Property RC5_Recordset.AbsolutePosition(RHS As Long)
    This.Put("AbsolutePosition", "l", RHS)
End Property
Property RC5_Recordset.Sort() As String
    Return This.Get("Sort")
End Property
Property RC5_Recordset.Sort(RHS As String)
    This.Put("Sort", "s", RHS)
End Property
Property RC5_Recordset.FieldValue(FieldKey As String) As vbVariant
    Return This.Get("FieldValue", "s", FieldKey)
End Property
Property RC5_Recordset.FieldValue(FieldKey As String, RHS As vbVariant)
    This.Put("FieldValue", "sv", FieldKey, @RHS.V)
End Property
Property RC5_Recordset.FieldValue(FieldIdx As Long) As vbVariant
    Return This.Get("FieldValue", "l", FieldIdx)
End Property
Property RC5_Recordset.FieldValue(FieldIdx As Long, RHS As vbVariant)
    This.Put("FieldValue", "lv", FieldIdx, @RHS.V)
End Property
Function RC5_Recordset.FieldName(FieldIdx As Long) As String
    Return This.Get("FieldName", "l", FieldIdx)
End Function
Function RC5_Recordset.ValueMatrix(RowIdx As Long, ColIdx As Long) As vbVariant
    Return Call("ValueMatrix", "ll", RowIdx, ColIdx)
End Function


'*** a Wrapper around the RC5-SQLite-cConnection (both, cConnection and cRecordset are quite ADO-compatible interface-wise, but don't depend on ADO) 
Type RC5_Connection Extends vbVariant
    Declare Constructor()
    Declare Function Version() As String
    Declare Function CreateNewDB(FileName As String, EncrKey As String="", EnableVBFunctions As Boolean=True) As Boolean
    Declare Function OpenDB     (FileName As String, EncrKey As String="", EnableVBFunctions As Boolean=True) As Boolean
    Declare Function Execute(SQL As String) As Boolean
    Declare Function OpenRecordset(SQL As String, ReadOnly As Boolean=False) As RC5_Recordset
    Declare Sub BeginTrans()
    Declare Sub CommitTrans()
    Declare Sub RollBackTrans()
End Type
Constructor RC5_Connection()
    V = New_c.Get("Connection")
End Constructor
Function RC5_Connection.Version() As String 
    Return This.Get("Version")
End Function
Function RC5_Connection.CreateNewDB(FileName As String, EncrKey As String="", EnableVBFunctions As Boolean=True) As Boolean
    Return This.Call("CreateNewDB", "ssb", FileName, EncrKey, EnableVBFunctions)
End Function
Function RC5_Connection.OpenDB(FileName As String, EncrKey As String="", EnableVBFunctions As Boolean=True) As Boolean
    Return This.Call("OpenDB", "ssb", FileName, EncrKey, EnableVBFunctions)
End Function
Function RC5_Connection.Execute(SQL As String) As Boolean
    Return This.Call("Execute", "s", SQL)
End Function
Function RC5_Connection.OpenRecordset(SQL As String, ReadOnly As Boolean=False) As RC5_Recordset
    Dim NewRs As RC5_Recordset = New_c.Get("DataSource")
    Dim TmpRs As vbVariant = This.Call("OpenRecordset", "sb", SQL, ReadOnly)
    If  TmpRs.VarType Then NewRs.Call("Init", "vw", @TmpRs, "") 
    Return NewRs
End Function
Sub RC5_Connection.BeginTrans()
   This.Call("BeginTrans")
End Sub
Sub RC5_Connection.CommitTrans()
    This.Call("CommitTrans")
End Sub
Sub RC5_Connection.RollBackTrans()
    This.Call("RollBackTrans")
End Sub


'*** a Wrapper around the RC5-cCollection (which comes with JSON-Support) 
Enum eJSONType
    JSONValue
    JSONObject
    JSONArray
End Enum
Dim Shared JSONLastKeyOrIndex As vbVariant, pJSONLastParent As vbVariant Ptr
Type RC5_JSON Extends vbVariant
    pJSON As RC5_JSON Ptr
    Declare Constructor()
    Declare Constructor(JSON_Type As eJSONType)
    Declare Constructor(JSON_String As String)
    Declare Constructor(JSON As RC5_JSON)
    Declare Destructor()
    Declare Sub Clear()
    Declare Function JSONType() As eJSONType
    Declare Function Exists(Key As String) As Boolean
    Declare Function Stringify() As String
    Declare Function Count() As Long
    Declare Sub Remove(KeyOrIndex As vbVariant)
    Declare Sub RemoveAll()
    Declare Operator[] (Key As String) ByRef As RC5_JSON 
    Declare Operator[] (Index As Long) ByRef As RC5_JSON 
    Declare Operator Let(RHS As RC5_JSON)
    Declare Operator Let(RHS As vbVariant)
    Declare Operator Let(RHS As String)
    Declare Operator Cast() As vbVariant
    Declare Operator Cast() As Long
    Declare Operator Cast() As LongInt
    Declare Operator Cast() As Double
    Declare Operator Cast() As String
    Declare Operator Cast() As Boolean
End Type
Constructor RC5_JSON()
End Constructor
Constructor RC5_JSON(JSON_Type As eJSONType)
    If JSON_Type = JSONObject Then V = New_c.Get("JSONObject")
    If JSON_Type = JSONArray  Then V = New_c.Get("JSONArray")
End Constructor
Constructor RC5_JSON(JSON_String As String)
    V = New_c.Call("JSONDecodeToCollection", "s", JSON_String) 
End Constructor
Constructor RC5_JSON(JSON As RC5_JSON)
    VariantCopy @V, @JSON.V 
End Constructor
Destructor RC5_JSON()
    If pJSON Then pJSON->vbV.Clear: Delete pJSON: pJSON = 0
End Destructor
Sub RC5_JSON.Clear()
    If pJSON Then pJSON->vbV.Clear: Delete pJSON: pJSON = 0
    If V.VT = vbObject Then RemoveAll
    VariantClear @V
End Sub
Function RC5_JSON.JSONType() As eJSONType
    If V.VT <> vbObject Then Return eJSONType.JSONValue
    Return IIf(This.Get("IsJSONObject"), eJSONType.JSONObject, eJSONType.JSONArray)
End Function
Function RC5_JSON.Exists(Key As String) As Boolean
    If V.VT = vbObject Then Return This.Call("Exists", "s", Key) Else Return False
End Function
Function RC5_JSON.Stringify() As String
    If V.VT = vbObject Then Return This.Call("SerializeToJSONString") Else Return ""
End Function
Function RC5_JSON.Count() As Long
    If V.VT = vbObject Then Return This.Get("Count") Else Return 0
End Function
Sub RC5_JSON.Remove(KeyOrIndex As vbVariant) 
    If KeyOrIndex.V.Vt = vbString Then
      If V.VT = vbObject And Count > 0 Then This.Call("Remove", "w", KeyOrIndex.V.bstrVal)
    Else
      If V.VT = vbObject Then This.Call("RemoveByIndex", "l", KeyOrIndex.V.lVal)
    End If
End Sub
Sub RC5_JSON.RemoveAll() 
    If V.VT = vbObject Then This.Call("RemoveAll")
End Sub
Operator RC5_JSON.[](Key As String) ByRef As RC5_JSON
    If pJSON Then pJSON->vbV.Clear: Delete pJSON: pJSON = 0
    pJSON = New RC5_JSON
      If Count Then pJSON->V = This.Get("Prop", "s", Key)
    Operator = *pJSON 
    JSONLastKeyOrIndex = Key: pJSONLastParent = @This
End Operator
Operator RC5_JSON.[](Index As Long) ByRef As RC5_JSON
    If pJSON Then pJSON->vbV.Clear: Delete pJSON: pJSON = 0
    pJSON = New RC5_JSON
      If Index >= 0 And Index < Count Then pJSON->V = This.Get("ItemByIndex", "l", Index)
    Operator = *pJSON 
    JSONLastKeyOrIndex = Index: pJSONLastParent = @This
End Operator
Operator RC5_JSON.Let(RHS As RC5_JSON)
    If pJSONLastParent = 0 Then 
        If @This = @RHS Then Exit Operator
        If V.VT Then VariantClear @V
        'VariantCopy @V, @RHS.V
        V=RHS.V
    ElseIf JSONLastKeyOrIndex.V.VT = vbString Then
        pJSONLastParent->Put("Prop", "wv", JSONLastKeyOrIndex.V.bstrVal, @RHS)
    Else 
        pJSONLastParent->Put("ItemByIndex", "lv", JSONLastKeyOrIndex.V.lVal, @RHS)
    End If
    pJSONLastParent = 0
End Operator
Operator RC5_JSON.Let(RHS As vbVariant)
    If pJSONLastParent = 0 Then Exit Operator
    If JSONLastKeyOrIndex.V.VT = vbString Then
       pJSONLastParent->Put("Prop", "wv", JSONLastKeyOrIndex.V.bstrVal, @RHS)
    Else
       For i As Long = pJSONLastParent->Get("Count") To JSONLastKeyOrIndex.V.lVal - 1: pJSONLastParent->Call("Add", "v", @RHS): Next
       pJSONLastParent->Put("Item", "lv", JSONLastKeyOrIndex.V.lVal, @RHS)
    End If
    pJSONLastParent = 0
End Operator
Operator RC5_JSON.Let(RHS As String)
    If pJSONLastParent = 0 Then Exit Operator
    If JSONLastKeyOrIndex.V.VT = vbString Then
       pJSONLastParent->Put("Prop", "ws", JSONLastKeyOrIndex.V.bstrVal, RHS)
    Else
       For i As Long = pJSONLastParent->Get("Count") To JSONLastKeyOrIndex.V.lVal - 1: pJSONLastParent->Call("Add", "s", RHS): Next
       pJSONLastParent->Put("Item", "ls", JSONLastKeyOrIndex.V.lVal, RHS)
    End If
    pJSONLastParent = 0
End Operator
Operator RC5_JSON.Cast() As vbVariant
    Operator = V: pJSONLastParent = 0
End Operator
Operator RC5_JSON.Cast() As Long
    Operator = vbV: pJSONLastParent = 0
End Operator
Operator RC5_JSON.Cast() As LongInt
    Operator = vbV: pJSONLastParent = 0
End Operator
Operator RC5_JSON.Cast() As Double
    Operator = vbV: pJSONLastParent = 0
End Operator
Operator RC5_JSON.Cast() As String 
    Operator = vbV: pJSONLastParent = 0
End Operator
Operator RC5_JSON.Cast() As Boolean
    Operator = vbV: pJSONLastParent = 0
End Operator
