﻿'another Helper-Module (along with mod3DHelpers.bas) for the 3DSurfaceDemo.bas, used for the Model-construction with:
'relative straight forward JSON-Definitions for the Key/Value-Pairs of each (scrollable) Widget (starting with the  
'Child-Node-Functions, ... the aggregation of these Child-Nodes is finally done in the Last Function of this Module)

Function CreateModelEntry_cmbSceneType() As RC5_JSON
    Dim Entry As RC5_JSON = RC5_JSON(JSONObject)
        Entry["Unit-Cube"] = 0
        Entry["Gaussianbell"] = 1
        Entry["Rosenbrock"] = 2
    Return Entry 
End Function
 
Function CreateModelEntry_cmbBackFaceStyle() As RC5_JSON
    Dim Entry As RC5_JSON = RC5_JSON(JSONObject)
        Entry["Backface normal"] = 0
        Entry["Backface greyed"] = 1
        Entry["BackFace none"] = 2
    Return Entry 
End Function
 
Function CreateModelEntry_chkAnimate() As RC5_JSON
    Dim Entry As RC5_JSON = RC5_JSON(JSONObject)
        Entry["Value"] = 0
    Return Entry 
End Function

Function CreateModelEntry_chkFullScreen() As RC5_JSON
    Dim Entry As RC5_JSON = RC5_JSON(JSONObject)
        Entry["Value"] = 0
    Return Entry 
End Function

Function CreateModelEntry_udnAzimuth() As RC5_JSON
    Dim Entry As RC5_JSON = RC5_JSON(JSONObject)
        For i As Long = 360 To 0 Step -1: Entry["Azimuth: " & i & "°"] = i: Next
    Return Entry 
End Function

Function CreateModelEntry_udnAltitude() As RC5_JSON
    Dim Entry As RC5_JSON = RC5_JSON(JSONObject)
        For i As Long = 180 To -180 Step -1: Entry["Altitude: " & i & "°"] = i: Next
    Return Entry 
End Function

Function CreateModelEntry_udnZoom() As RC5_JSON
    Dim Entry As RC5_JSON = RC5_JSON(JSONObject)
        For i As Long = 8 To 1 Step -1: Entry["Zoom: " & i / 4 * 100 & "%"] = i / 4: Next
    Return Entry 
End Function

Function CreateModelEntry_udnAlpha() As RC5_JSON
    Dim Entry As RC5_JSON = RC5_JSON(JSONObject)
        For i As Long = 10 To 3 Step -1: Entry["Alpha: " & i * 10 & "%"] = i / 10: Next
    Return Entry 
End Function

Function CreateModelEntry_udnPerspDistance() As RC5_JSON
    Dim Entry As RC5_JSON = RC5_JSON(JSONObject)
        For i As Long = 10 To 2 Step -1: Entry["Persp-Dist: " & 2 ^ i] = 2 ^ i: Next
    Return Entry 
End Function

'here we accumulate the "Sub-JSON-Lists" in a Parent-JSON-Object (with Keys, that match the Widget-Names, to make things easier)
Function CreateNewModel() As RC5_JSON
    Dim Model As RC5_JSON = RC5_JSON(JSONObject)
        Model["cmbSceneType"] = CreateModelEntry_cmbSceneType
        Model["cmbBackFaceStyle"] = CreateModelEntry_cmbBackFaceStyle
        Model["chkAnimate"] = CreateModelEntry_chkAnimate
        Model["chkFullScreen"] = CreateModelEntry_chkFullScreen
        Model["udnAzimuth"] = CreateModelEntry_udnAzimuth
        Model["udnAltitude"] = CreateModelEntry_udnAltitude
        Model["udnZoom"] = CreateModelEntry_udnZoom
        Model["udnAlpha"] = CreateModelEntry_udnAlpha
        Model["udnPerspDistance"] = CreateModelEntry_udnPerspDistance
    Return Model 
End Function
 